import Test.QuickCheck
import Control.Monad

data Tree a = Leaf | Branch (Tree a) a (Tree a)
     deriving (Show)

instance Arbitrary a => Arbitrary (Tree a) where
  arbitrary = sized arbTree

arbTree 0 = return Leaf
arbTree n | n > 0 = frequency[(1, return Leaf),
                              (3, liftM3 Branch shrub arbitrary shrub)]
    where
        shrub = arbTree (n `div` 2)


treeHeight               :: Tree a -> Int
treeHeight Leaf           = 1
treeHeight (Branch l _ r) = 1 + max (treeHeight l) (treeHeight r)


prop_True   :: Tree Bool -> Property
prop_True t  = collect (treeHeight t) $ True
