import Test.QuickCheck

insert :: Ord a => a -> [a] -> [a]
insert x []  = [x]
insert x r@(y:ys)
    | x <= y     = x : r
    | otherwise  = y : insert x ys

ordered :: (Ord a) => [a] -> Bool
ordered []   = True
ordered [x]  = True
ordered (x1:r@(x2:xs))
    | x1 <= x2   = ordered r
    | otherwise  = False


prop_InsertOrdered     :: Integer -> [Integer] -> Property
prop_InsertOrdered x xs = ordered xs ==>
                          trivial (length xs <= 2) $
                          ordered (insert x xs)

-- vorgegeben:
trivial p = classify p "trivial"



prop_InsertOrdered2     :: Integer -> [Integer] -> Property
prop_InsertOrdered2 x xs = ordered xs ==>
                          classify (null xs) "empty lists" $
                          classify (length xs == 1) "unit lists" $
                          ordered (insert x xs)



prop_InsertOrdered3     :: Integer -> [Integer] -> Property
prop_InsertOrdered3 x xs = ordered xs ==> collect (length xs) $
                                         ordered (insert x xs)
