import Test.QuickCheck

type Queue a = [a]
empty = []
add x q = q ++ [x]
isEmpty q = null q
front (x:q) = x
remove (x:q) = q

type Queue2 a = ([a], [a])
empty2 = ([],[])
add2 x (f,b) = (f, x:b)
isEmpty2 (f,b) = null f
front2 (x:f, b) = x
remove2 (x:f, b) = flipQ (f,b)

flipQ ([], b) = (reverse b, [])
flipQ q       = q


-- Damit muss nicht fuer jede Property eine Typsignatur gesetzt werden:
retrieve      :: Queue2 Integer -> Queue Integer
retrieve (f,b) = f ++ reverse b

prop_empty      = retrieve empty2 == empty
prop_add x q    = invariant q ==> retrieve (add2 x q) == add x (retrieve q)
prop_isEmpty q  = invariant q ==> isEmpty2 q == isEmpty (retrieve q)
prop_front q    = invariant q && not (isEmpty2 q) ==> front2 q == front (retrieve q)
prop_remove q   = invariant q && not (isEmpty2 q) ==> retrieve (remove2 q) == remove (retrieve q)

invariant :: Queue2 Integer -> Bool
invariant (f,b) = not (null f) || null b


